#include<iostream.h>
#include<stdlib.h>
#include<math.h>
#include<ctype.h>
#include<string.h>

enum types {DELIMITER = 1, VARIABLE, NUMBER, TRIG};

const int NUMVARS = 26;
class parser {
	char *exp_ptr;
   char element[80];
   char tok_type;
   double vars[NUMVARS];

   void process_stage_1(double &result);
   void process_stage_2(double &result);
   void process_stage_3(double &result);
   void process_stage_4(double &result);
   void process_stage_5(double &result);
   void process_stage_6(double &result);
   void get_value(double &result);
   void get_element();
   void putback();
   void print_error(int error);
   double search_vars(char *s);
   int isdelim(char c);
public:
	parser();
   double process_stage_main(char *exp);
};


main()
{
	char expstr[80];
   cout << "To stop input point.\n";
   parser ob;
   for(;;) {
   	cout << "Input expression:  ";
{      cin.getline(expstr, 79);    }
      if(*expstr=='.') break;
      cout << "Answer: " << ob.process_stage_main(expstr) <<"\n\n";
      };
  return(0);
}

parser::parser()
{
 	int i;

   exp_ptr = NULL;

   for(i=0; i<NUMVARS; i++) vars[i] = 0.0;
}

double parser::process_stage_main(char *exp)
{
	double result;
   exp_ptr = exp;

   get_element();
   if(!*element) {
   	print_error(2);
      return 0.0;
   }
   process_stage_1(result);
   if(*element){ print_error(0);}
   return result;
}

void parser::process_stage_1(double &result)
{
	int slot;
   char ttok_type;
   char temp_element[80];

   if(tok_type==VARIABLE) {
   	strcpy(temp_element, element);
      ttok_type = tok_type;
      slot = toupper(*element) - 'A';
      get_element();
      if(*element != '=') {
      	putback();
         strcpy(element, temp_element);
         tok_type = ttok_type;
   	}
      else {
      	get_element();
         process_stage_2(result);
vars[slot] = result;
         return;
      }
   }
   process_stage_2(result);
}

void parser::process_stage_2(double &result)
{
	register char op;
   double temp;

   process_stage_3(result);
   while((op = *element) == '+' || op == '-') {
   	get_element();
      process_stage_3(temp);
      	switch(op) {
         	case '-':
            	result = result - temp;
               break;
            case '+':
            	result = result + temp;
               break;
            }
         }
}
void parser::process_stage_3(double &result)
{
	register char op;
   double temp;
   process_stage_4(result);
 	while(( op = *element) == '*' || op == '/' || op == '%') {
   get_element();
   process_stage_4(temp);
   switch(op) {
   	case '*':
      	result = result*temp;
         break;
      case '/':
         result = result/temp;
         break;
      case '%':
      	result = (int) result % (int) temp;
         break;
      }
   }
}

void parser::process_stage_4(double &result)
{
	double temp, ex;

   process_stage_5(result);
   if(*element=='^')
   {
   	get_element();
      process_stage_4(temp);
      ex = result;
      result=pow(ex,temp);
      }
}
void parser::process_stage_5(double &result)
{
	register char op;

   op = 0;
   if((tok_type == DELIMITER) && (*element== '+' || *element == '-'))
   {
   	op = *element;
      get_element();
   }
   process_stage_6(result);
   if(op == '-') result = -result;

}

void parser::process_stage_6(double &result)
{
     if((*element == '(')) {
   	get_element();
      process_stage_2(result);
      if (*element != ')')
      	print_error(1);
      get_element();
   }
   else if ((*element == '[')) {
   	get_element();
      process_stage_2(result);
      result=abs(result);
      if (*element != ']')
      	print_error(1);
      get_element();
   }
   else get_value(result);
}

void parser::get_value(double &result)
{
	switch(tok_type) {
   	case VARIABLE:
         result = search_vars(element);
         get_element();
         return;
      case NUMBER:
      	result = atof(element);
         get_element();
         return;
      default:
      	print_error(0);
   }
}

void parser::putback()
{
	char *t;
   t = element;
   for(; *t; t++) exp_ptr --;
}

void parser::print_error(int error)
{
	static char *e[]= {
   		"Sintax Error",
         "UnClosed Skobka"
         "No Expression to compile"
     };
     cout << e[error] << endl;
}
void parser::get_element()
{
	register char *temp;
   tok_type=0;
   temp=element;
   *temp='\0';

   if(!*exp_ptr) return;

   while (isspace(*exp_ptr)) ++exp_ptr;

   if(strchr("+-*/%^=()[]",*exp_ptr))
    {
     tok_type=DELIMITER;
     *temp++=*exp_ptr++;
    }
   else if (isalpha(*exp_ptr))
    {
     while(!isdelim(*exp_ptr)) *temp++= *exp_ptr++;
     if (*element!='pi'){tok_type=VARIABLE;}
     else {tok_type=TRIG;}
    }
   else if (isdigit(*exp_ptr))
    {
     while (!isdelim(*exp_ptr)) *temp++ = *exp_ptr++;
     tok_type=NUMBER;
    }
*temp='\0';
}

int parser::isdelim(char c)
{
	if(strchr(" +-/*%^=()[]", c) || c==9 || c=='\r' || c==0)
		return 1;
   return 0;
}
double parser::search_vars(char *s)
{
	if(!isalpha(*s)) {
   	print_error(1);
      return 0.0;}
      return vars[toupper(*element)-'A'];

 }
